package com.sv.service.api;

import com.github.pagehelper.PageHelper;
import com.sv.entity.VenueLessonTag;
import com.sv.mapper.VenueLessonTagMapper;
import com.ydd.framework.core.common.Pagination;
import com.ydd.framework.core.service.impl.BaseServiceImpl;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;

/**
 * Service - 课程拥有的tag名称
 *
 * @author lihong
 * @since 2018-08-06
 */
@Service
@Transactional(readOnly = true)
public class VenueLessonTagService extends BaseServiceImpl{

	private final Logger logger = LoggerFactory.getLogger(VenueLessonTagService.class);

	@Resource
	private VenueLessonTagMapper venueLessonTagMapper;

	/**
	 * 创建课程拥有的tag名称
	 *
	 * @param venueLessonTag 课程拥有的tag名称
	 */
	@Transactional
    public void save(VenueLessonTag venueLessonTag) {
		if (venueLessonTag.getId() != null && venueLessonTag.getId() > 0) {
			// 更新
			venueLessonTagMapper.update(venueLessonTag);
		} else {
			// 新建
			venueLessonTagMapper.insert(venueLessonTag);
		}
	}

	/**
	 * 更新课程拥有的tag名称
 	 *
	 * @param venueLessonTag 课程拥有的tag名称
	 */
	@Transactional
    public void update(VenueLessonTag venueLessonTag) {
		venueLessonTagMapper.update(venueLessonTag);
	}

	/**
	 * 删除课程拥有的tag名称
	 *
	 * @param id 编号
   	 * @return 删除数量
	 */
	@Transactional
    public Integer delete(Integer id) {
		if (id == null || id <= 0) {
			return 0;
		}
		return venueLessonTagMapper.delete(id);
	}

	/**
	 * 删除课程拥有的tag名称
	 *
	 * @param ids 编号数组
	 * @return 删除数量
	 */
	@Transactional
    public Integer deleteByIds(Integer[] ids) {
		if (ids == null || ids.length == 0) {
			return 0;
		}
		return venueLessonTagMapper.deleteByIds(ids);
	}

	/**
	 * 查询课程拥有的tag名称
	 *
	 * @param id 编号
	 * @return 课程拥有的tag名称
	 */
	public VenueLessonTag findById(Integer id) {
		return venueLessonTagMapper.findById(id);
	}

	/**
	 * 查询课程拥有的tag名称
	 *
	 * @param pagination 分页信息
	 * @return 分页结果
	 */
	public Pagination findPage(Pagination pagination) {
		PageHelper.startPage(pagination.getPage(), pagination.getPageSize());
		PageHelper.orderBy("id desc");
		pagination.setQueryResult(venueLessonTagMapper.findAll());
		return pagination;
	}

}

